/* 
 * File:   AjacencyGraphy.h
 * Author: NanGao
 *
 * Created on August 31, 2011, 3:04 PM
 */

#ifndef _AJACENCYGRAPHY_H
#define	_AJACENCYGRAPHY_H

#include <stdio.h>
#include <stdlib.h>

typedef struct adGenome
{
    int geneID;
    int next;
    int marked;//component mark to indicate different componets
	int pos;
	int type;//1 for unbalanced path(even edges), 2 for balanced path(odd edges), 3 for circle
}geNome;

typedef struct geNomeScore
{
    int score;
    double avgScore;
}dcjScore;

typedef struct scoreAndPos
{
    int pos;
    int score;
}scoreAndPos;

typedef struct geNomeRatioScore
{
    double score;
    double avgScore;
}ratioScore;

typedef struct idAndPos
{
	int pos;
	int id;
	int change;
}idAndPos;

typedef struct comPonent
{
	int pos;
	int id;
	int change;
}comPonent;

typedef struct Score
{
	dcjScore *scoreA;
	dcjScore *scoreB;
	dcjScore *scoreC;
	ratioScore * ratScore;
	dcjScore *sumScore;
	geNome ** newGenomes;
	geNome **newPool;
	geNome **recordGes;
	geNome **oriPool;
		
}Score;
#endif	/* _AJACENCYGRAPHY_H */

