/* 
 * fILE:   DcjDistance.cpp
 * Author: Nan Gao
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include "DcjDistance.h"
#include "AjacencyGraphy.h"
using namespace std;

void iniGe (geNome* gA, geNome* gB, int geLen);
bool comfun(idAndPos A, idAndPos B)
{
	return (A.pos < B.pos);
}

void showStructure(geNome *gA, int geLen, char* outfile)
{
	ofstream outf(outfile);		
	outf<< "The structure is " << endl;
	for (int i =0; i < geLen*2 +2; i++)
		{						
			outf << "gA[i].geneID " << gA[i].geneID << "  gA[i].marked " << gA[i].marked << "  gA[i].next " << gA[i].next << "  gA[i].type " << gA[i].type << " gA[i].pos "<< gA[i].pos << endl; 									
		}
	outf << "the end!" << endl;
}

void CountDcjDistance_o (geNome *gA, geNome *gB, int geLength, int* step)//geLen is based on the adjacency graphy distance; return distance and component#
{
	  int dcjDis = 0;
    int nCircle = 0;
    int nPath = 0;
    int ifOdd = 0;   
    int markedGen = 0;
    geNome *tempgA;//temp point to point the genome
    geNome *tempgB;
    tempgA = new geNome[geLength];
    tempgB = new geNome[geLength];
	  for (int i = 0; i < geLength; i++)
    {     
        gA[i].marked = 0;       
        gB[i].marked = 0;
		gA[i].type = 0;
		gB[i].type = 0;
    }
    //initial
    for (int i = 0; i < geLength; i++)
    {
        tempgA[i].geneID = gA[i].geneID;
        tempgA[i].marked = gA[i].marked;
        tempgA[i].next = gA[i].next;
        tempgB[i].geneID = gB[i].geneID;
        tempgB[i].marked = gB[i].marked;
        tempgB[i].next = gB[i].next;        
    }
    iniGe(tempgA, gA, (geLength - 2)/2);
	  iniGe(tempgB, gB, (geLength - 2)/2);
    bool findCircle = false;
    bool findPath = false;
		int pathEnd = 0; // 1 for A, 2 for B
		int type = 0;// record the type of component 1 for unbalanced path(even edges), 2 for balanced path(odd edges), 3 for circle 
		int indexA = 0;
		int indexB = 0;
		int indexComponent = 1;//record the index of different components
    for (int i = 0; i<geLength; i++)
    {      
        indexA = i;
        indexB = 0;
        markedGen = tempgA[indexA].geneID;
      
        if (tempgA[indexA].marked)
        {	
            continue;//if scaned this gene then continue
        }
        else
        {
            findCircle = false;//clear bool various
            findPath = false;
            ifOdd = 0;//use point number to decide if the path is odd or even
            while (1)
            {			
				tempgA[indexA].marked = indexComponent; 
                ifOdd++;
                
				if (tempgA[indexA].next == 0 || tempgA[indexA].next == geLength -1)//the cap for geLen is 5
        {
					
					pathEnd = 1;// end with A current begin with A
          findPath =  true;//one while break, find a path
					type = 1;// AA PATH
          //if gB has one gene that cannot be scaned at the start				
					ifOdd++;
					tempgA[tempgA[indexA].next].marked = indexComponent;
                    break;
                }
                // has adjancency              
                indexA = tempgA[indexA].next;//rigt now the tempgA's indexA              
                indexB = tempgA[indexA].geneID;//right now tempgB's indexB           
                if (tempgA[indexA].marked)
                {				
                    break;//break while
                }
                else
                {
                    tempgA[indexA].marked = indexComponent;
                    ifOdd++;
                }
                
                if (tempgB[indexB].marked)// go to genome B
                {			
                    break;//what's the situation 
                }else
                {
                    tempgB[indexB].marked = indexComponent;
                    ifOdd++;
                }

                if (tempgB[indexB].next == 0 || tempgB[indexB].next == geLength -1)//the cap for 5 geLen
                {
										type = 2;// AB path
										nPath++;
										pathEnd = 2;// end with B current begin with A
                    findPath = true;						
										tempgB[tempgB[indexB].next].marked = indexComponent;				
										ifOdd++;					
                    break;//break while find a path between genome A and genome B
                }
                else
                {
                    
                    indexA = tempgB[indexB].next;
										tempgB[indexB].marked = indexComponent;
										tempgB[indexA].marked = indexComponent;
										ifOdd++;                   
                }
                //if find a circle or continue loop between A and B
                if (tempgA[indexA].geneID == markedGen)
                {					
                    findCircle = true;//find the start gene in A and find a circle
                    break;// break while and find a circle
                }
            }

            if (findCircle)
            {
                nCircle++;
                ifOdd = 0;
				type = 3;
            }						
			//record the type for gA and gB
			for (int i = 0; i < geLength; i++)
			{
				if (tempgA[i].marked == indexComponent)
				{					
					tempgA[i].type = type;
				}
				if (tempgB[i].marked == indexComponent)
				{
					tempgB[i].type = type;	
				}
			}

			type = 0;
			indexComponent++;//ready for next component
        }
    }
	//search from B which may solve deletion and insertion
	int changeType = 0;
	for (int i = 0; i < geLength; i++)
	{
		int index = 0;
		int com  = 0;
		int typeB = 0;
		if (tempgB[i].marked == 0)// fing missed gB part
		{
			if (tempgB[i].geneID == 0)
			{
				cout << "find one where gB.geneID = 0" << endl;
				index = tempgB[i].next;
				com = tempgA[index].marked;
			  typeB = tempgA[index].type;
				tempgB[i].marked = com;
				tempgB[index].marked = com;
				tempgB[i].type = typeB;
				tempgB[index].type = typeB;
				//two situation end with A or end with B
				if (typeB == 1) // end with A
				{	
					changeType = 2;// from AA path to AB path
					for (int j = 0;  j < geLength; j++)//change type in the com
					{
						if (tempgA[j].marked == com) tempgA[j].type = changeType;
						if (tempgB[j].marked == com) tempgB[j].type = changeType;
					}
					nPath++;
				}
				if (typeB == 2) //end with B
				{
					changeType = 1;// from AB path to BB path
					for (int j = 0;  j < geLength; j++)//change type in the com
					{
						if (tempgA[j].marked == com) tempgA[j].type = changeType;
						if (tempgB[j].marked == com) tempgB[j].type = changeType;
					}
					nPath--;
				}

			}else 
			{				
				if ( tempgB[i].next != 401)//doesn't the last adjacency 
				{
					
					index = tempgB[i].next;
					com = tempgA[index].marked;
					typeB = tempgA[index].type;
					tempgB[i].marked = com;
					tempgB[i].type = typeB;
					tempgB[index].type = typeB;
					tempgB[index].marked = com;
				}else
				{
					
					index = tempgB[i].next;
					com = tempgA[i].marked;
					typeB = tempgA[i].type;
					tempgB[i].marked = com;
					tempgB[index].marked = com;
					tempgB[i].type = typeB;
					tempgB[index].type = typeB;
				}
				
				if (typeB == 1) 
				{
					changeType = 2;// from AA path to AB path
					for (int j = 0;  j < geLength; j++)//change type in the com
					{
						if (tempgA[j].marked == com) tempgA[j].type = changeType;
						if (tempgB[j].marked == com) tempgB[j].type = changeType;
					}
					nPath++;
				}
			}
			
		}	
	}

	 for (int i = 0; i < geLength; i++)
    {      		
       gA[i].marked = tempgA[i].marked; 
			 gA[i].type = tempgA[i].type;      
       gB[i].marked = tempgB[i].marked;
			 gB[i].type = tempgB[i].type;                
    }
    //delete tempA and tempB
    delete[] tempgA;
    delete[] tempgB;

    dcjDis = (geLength-2)/2 - (nCircle + (nPath / 2));//caculate dcj distance
    step[0] = dcjDis;// the Dcj distance
	  step[1] = indexComponent - 1 ;// the number of components
    
}

 vector<idAndPos> transGenome(geNome *gA, int genLen)
{
	vector<idAndPos> transGA(genLen);
	for (int i = 0; i < genLen; i++)
	{
		transGA[i].id = gA[i].geneID;
		transGA[i].pos = gA[i].pos;
		transGA[i].change = 0;
	}
	return transGA;
}

void refreshGenome(geNome* gA, int genLen, vector<idAndPos> tempGA)
{
	int id = 0;
	int mark = 0;
	for (int i = 0; i < genLen; i++)
	{
		id = tempGA[i].id;
		mark = tempGA[i].change;
		gA[id].marked = mark;
	}
}

void CountDcjDistance (geNome *gA, geNome *gB, int geLength, int* step)//geLen is based on the adjacency graphy distance; return distance and component#
{
	int dcjDis = 0;
    int nCircle = 0;
    int ABPath = 0;
	int AAPath = 0;
	int markedGen = 0;
	int com = 0;
	vector<idAndPos> tempGA(geLength);
	vector<idAndPos> tempGB(geLength);
	//initial genomes
	for (int i = 0; i < geLength; i++)
	{
		gA[i].marked = 0;
		gA[i].type = 0;
		gB[i].marked = 0;
		gB[i].type = 0;
	}
	tempGA = transGenome(gA, geLength);
	tempGB = transGenome(gB, geLength);
	sort(tempGA.begin(), tempGA.end(), comfun);
	sort(tempGB.begin(), tempGB.end(), comfun);
	//do dcjdistance
	for (int i = 0; i < geLength; i++)
	{
		if(tempGA[i].change == 0)
		{
			markedGen = tempGA[i].id;
			int nextID = 0;
			int gBID = 0;
			int gAID = 0;
			com++;//find a new component
			gAID = i;
			markedGen = tempGA[gAID].id;
			while(1)
			{		
				tempGA[gAID].change = com;				
				nextID = gA[tempGA[gAID].id].next;
			
				gAID = gA[nextID].pos;
				tempGA[gAID].change = com;

				//judge if get the end of gA
				
				if (nextID == geLength || nextID == 0)
				{
					gAID = gA[nextID].pos;
					tempGA[gAID].change = com;
					break;
				}else
				{
					gAID = gA[nextID].pos;
					tempGA[gAID].change = com;
				}
				

				//find tempGB
				gBID = gB[nextID].pos;//using pos as index in tempGB
				if(tempGB[gBID].change != 0)
				{
					cout << "error when find in gB: " << nextID << endl;
				}
				else
				{
					tempGB[gBID].change = com;
					nextID = gB[tempGB[gBID].id].next;//find next geneID in gB
				}
	
				gBID = gB[nextID].pos;
				tempGB[gBID].change = com;
				//get position in gA
				gAID = gA[nextID].pos;
				//judge if met the circle 
				if(nextID == markedGen)
					{
				
						break;
					}
				//judge if get the end of gB

				
				if (nextID == geLength || nextID == 0)
				{
					gBID = gB[nextID].pos;
					tempGB[gBID].change = com;
					break;
				}
				else
				{
					gBID = gB[nextID].pos;
					tempGB[gBID].change = com;					
					gAID = gA[nextID].pos;					
					if(nextID == markedGen)
					{					
						break;
					}
				}		
			}					
		}
	}

	//go through gB to find omit genome
	for (int i = 1; i < geLength; i++)
	{
		int com = 0;
		int nextID = 0;
		int posGene = 0;
		int geneID = 0;
		if(tempGB[i].change == 0)
		{
			cout<< "find omit gene in gB " << tempGB[i].id << endl;
			//find omit gB give the same com as gA
			geneID = tempGB[i].id;
			posGene = gA[geneID].pos;
			com = tempGA[posGene].change;
			tempGB[i].change = com;
			//gB omit gene's next
			geneID = gB[geneID].next;
			posGene = gB[geneID].pos;
			tempGB[posGene].change = com;
		}
	}
	
	//calculate component type
	int gAhead = 0;
	int gAtail = 0;
	int gBhead = 0;
	int gBtail = 0;
	int judgePath = 0;
	gAhead = tempGA[0].change;
	gAtail = tempGA[geLength-1].change;
	gBhead = tempGB[0].change;
	gBtail = tempGB[geLength-1].change;
	//go through each com
	vector<comPonent> component(geLength);
	for (int i = 0; i < geLength; i++)
	{
		component[i].change = -1;
	}

	for (int i = 0; i < com; i++)
	{
		for (int j = 0; j < geLength; j++)
		{
			if(tempGA[j].change == com)
			{

			}
		}
	}
	for (int i = 0; i < com; i++)
	{
		if (i != gAhead && i != gAtail && i != gBhead && i != gBtail )
		{
			nCircle++;
		}
	}
	//only three situation and we only consider one part
	if (gAhead == gBhead)
		ABPath = ABPath + 2;
	if (gAhead == gAtail)
		AAPath = AAPath + 2;
	if (gAhead == gBtail)
		ABPath = ABPath + 2;

	nCircle = com - ABPath - AAPath;
	
	int distance = (geLength - 2)/2 - nCircle - ABPath/2; 
	step[0] = distance;
	step[1] = com;
	//refresh gA and gB
	refreshGenome(gA, geLength, tempGA);
	refreshGenome(gB, geLength, tempGB);
}

