/* 
 * fILE:   GaOperation.cpp
 * Author: Nan Gao
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctime>
#include <time.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include "AjacencyGraphy.h"
#include "DcjDistance.h"
#include "GaOperation.h"
#include "DcjOperation.h"
#include "structs.h"
#include "ASortingSequence.h"

using namespace std;
 dcjScore *sumScore;
extern distmem_t distmem; 
extern Score score;
void iniGe (geNome* gA, geNome* gB, int geLen);
bool compfunction(scoreAndPos A, scoreAndPos B)
    {
        return (A.score < B.score);
    }

bool compfunction2(scoreAndPos A, scoreAndPos B)
    {
    return (A.score > B.score);
    }

bool compfunction3(idAndPos A, idAndPos B)
{
	return (A.id == B.id);
}

bool compfunction4(idAndPos A, idAndPos B)
{
	return (A.id < B.id);
}

bool comfunction5(idAndPos A, idAndPos B)
{
	return (abs(A.id) < abs(B.id));
}

bool comfunction6(idAndPos A, idAndPos B)
{
	return (abs(A.id) == abs(B.id));
}

void printFun(geNome *gA, int geLen)
{
    for (int i = 0; i < geLen; i++)
    {
		cout << "geneID: " << gA[i].geneID  << "	gene pos: " << gA[i].pos << "     nextID: " << gA[i].next << endl;
		
    }
    cout << "print end" << endl;
}

void printGenoFun(geNome **orig, int geLen, int pop)
{
    for (int i = 0; i < pop; i++)
    {
        for (int j = 0; j < geLen; j++)
        {
            cout << "geneID: " << orig[i][j].geneID << "    nextID: " << orig[i][j].next << endl;
        }
        cout << "print out one genome in pool" << endl;
    }
}

vector<idAndPos> transGene(geNome *gA, vector<idAndPos> geneA, int genLen) // genLen = 402 geneA is 200 length
{
	 vector<idAndPos> tP1(genLen);
	 int Length = (genLen - 2)/2;// the original length of genome
	 for (int i = 0; i < genLen; i++)
	 {
			tP1[gA[i].pos].id = gA[i].geneID;
			tP1[gA[i].pos].change = 0;
			tP1[gA[i].pos].pos = gA[i].pos;			
	 }
	 //translate it into original format
	for (int i = 0; i < genLen-2; i +=2)
	{
		int pos = i/2;
		if (tP1[i+1].id % 2 == 0) 
		{			
			geneA[pos].id = 0 - tP1[i+1].id/2;
			geneA[pos].pos = pos;
			geneA[pos].change = 0;					
		}
		else 
		{
			geneA[pos].id = (tP1[i+1].id + 1)/2;
			geneA[pos].pos = pos;
			geneA[pos].change = 0;					
		}				
	}
	return geneA;
}

void GaDcjOperation(geNome *gA, geNome *gB, geNome *gC, int geLen, int pop, char *pathOut, Score score, char *filepath)// geLen for 200
{
	int popGe = pop;
  int genLen = geLen*2;
	int generN = 0;
	int replNum = 10;//replace # for every generation
	//caculate DCJ distance 
	int* stepAB = new int[2];// 0 for distance, 1 for component#
	int* stepAC = new int[2];
	int* stepBC = new int[2];

	CountDcjDistance(gA, gB, genLen+2, stepAB);
	CountDcjDistance(gA, gC, genLen+2, stepAC);
	CountDcjDistance(gB, gC, genLen+2, stepBC);
	int dA = (stepAB[0] + stepAC[0] - stepBC[0])/2;
	int dB = (stepAB[0] + stepBC[0] - stepAC[0])/2;
	int dC = (stepBC[0] + stepAC[0] - stepAB[0])/2;

	ofstream outf(pathOut);	
	outf << "the total steps is: " << (stepAB[0] + stepAC[0] + stepBC[0])/2<< endl;	
	outf << "stepAB is " << stepAB[0] << " stepAC is " << stepAC[0] << " stepBC is " << stepBC[0] << endl;
	outf << "dA is " << dA << " dB is " << dB << " dC is " << dC << endl;

	int dcjNum = 0;
	int rePosition = 0;
	vector<scoreAndPos> medScoreArray(popGe);//array to store the median score for each genome
	vector<scoreAndPos>::iterator it;

	geNome *parent1;//the first parent
	geNome *parent2;//the second parent
	parent1 = new geNome[genLen+2];
	parent2 = new geNome[genLen+2];
	
	//while loop
	geNome* oriGene = new geNome[genLen + 2];
	geNome* dcjGenome = new geNome[genLen + 2];
	geNome* goodGenome = new geNome[genLen + 2];
	geNome* dcjOri = new geNome[genLen + 2];//for record the original dcj operiation geome
	geNome* goodOri = new geNome[genLen + 2];//for record the original good genome before mutation
	int* stepA = new int[2];//record distance with gA
	int* stepB = new int[2];//record distance with gB
	int* stepC = new int[2];//record distance with gC

	do
  {
		//calculate each genome dcjscore
     for (int i = 0; i < popGe; i++)
     {								
			iniGe(oriGene, score.oriPool[i],geLen);
			CountDcjDistance(score.oriPool[i], gA, genLen+2, stepA);			
			iniGe(oriGene, score.oriPool[i],geLen);
			CountDcjDistance(score.oriPool[i], gB, genLen+2, stepB);
			iniGe(oriGene, score.oriPool[i],geLen);
			CountDcjDistance(score.oriPool[i], gC, genLen+2, stepC);

      score.scoreA[i].score = stepA[0];
			score.scoreB[i].score = stepB[0];
			score.scoreC[i].score = stepC[0];
			// mix select rule												
			score.sumScore[i].score =  score.scoreA[i].score + score.scoreB[i].score + score.scoreC[i].score;// the total distance among gA, gB and gC for one median genome																													
			medScoreArray[i].score = score.sumScore[i].score;
      medScoreArray[i].pos = i;//record the position of genome
     }

		//sort the medScoreArray and decide
        sort(medScoreArray.begin(), medScoreArray.end(), compfunction);
        it = medScoreArray.begin();
       
				outf << "Loop " << generN << " the min total score for this loop is " << (*it).score << endl;
        if ((*it).score < TotalMinScore)// get the begin struct element of vector
        {
            break;
        }                             
        
		//generate a new genomes pool, let the first 10 best genomes to replace the worst 10(replNum) genomes
		for (int i = 0; i < popGe; i++)
		{
			for (int j = 0; j < genLen+2; j++)
			{
				score.newPool[i][j] = score.oriPool[i][j];					
			}
		}		
		
		//record the original best 10 genomes 
		for (int i = 0; i < 10; i++)
		{
			int posb = 0; //the first i_th best position
			posb = medScoreArray[i].pos;
			iniGe(score.recordGes[i], score.oriPool[posb],geLen);		
		}

		//run block change to from parents pool to get new genome
		//random find the parents
		int blockExNum = 0;
		int sortN = 0;
		int posGe1 = 0;
		int posGe2 = 0;
		int pScore1 = 0;
		int pScore2 = 0;

		while(blockExNum < (popGe-10)/2)//for the parents generation's best 10 genomes so here is popGe-10
		{	
			//get the parent1 & parent2
			posGe1 = (int)rand() % popGe;			
			for (int delay = 0; delay < 100000; delay++)
			{		
			}		

			posGe2 = (int)rand() % popGe;		
			//calcuate every parent's sum score for distance
			//for p1
			CountDcjDistance(score.oriPool[posGe1], gA, genLen+2, stepA);
			CountDcjDistance(score.oriPool[posGe1], gB, genLen+2, stepB);
			CountDcjDistance(score.oriPool[posGe1], gC, genLen+2, stepC);           	
			pScore1 = stepA[0] + stepB[0] + stepC[0];
			
			//for p2
			CountDcjDistance(score.oriPool[posGe2], gA, genLen+2, stepA);
			CountDcjDistance(score.oriPool[posGe2], gB, genLen+2, stepB);
			CountDcjDistance(score.oriPool[posGe2], gC, genLen+2, stepC);    
			pScore2 = stepA[0] + stepB[0] + stepC[0];
			//caculate the distance between p1 and p2; random get DCJ steps; get component between these two genomes
			CountDcjDistance(score.oriPool[posGe2], score.oriPool[posGe1], genLen+2, stepA);
			if(pScore1 < pScore2)
			{
				for(int i = 0; i <  genLen+2; i++)
				{
					dcjGenome[i].geneID = score.oriPool[posGe2][i].geneID;
					dcjGenome[i].marked = score.oriPool[posGe2][i].marked;
					dcjGenome[i].next= score.oriPool[posGe2][i].next;
					dcjGenome[i].pos = score.oriPool[posGe2][i].pos;
					dcjGenome[i].type = score.oriPool[posGe2][i].type;
				
					goodGenome[i].geneID = score.oriPool[posGe1][i].geneID;
					goodGenome[i].marked = score.oriPool[posGe1][i].marked;
					goodGenome[i].next= score.oriPool[posGe1][i].next;
					goodGenome[i].pos = score.oriPool[posGe1][i].pos;
					goodGenome[i].type = score.oriPool[posGe1][i].type;
				}			
			}else
			{
				for(int i = 0; i <  genLen+2; i++)
				{
					dcjGenome[i].geneID = score.oriPool[posGe1][i].geneID;
					dcjGenome[i].marked = score.oriPool[posGe1][i].marked;
					dcjGenome[i].next= score.oriPool[posGe1][i].next;
					dcjGenome[i].pos = score.oriPool[posGe1][i].pos;
					dcjGenome[i].type = score.oriPool[posGe1][i].type;
					
					goodGenome[i].geneID = score.oriPool[posGe2][i].geneID;
					goodGenome[i].marked = score.oriPool[posGe2][i].marked;
					goodGenome[i].next= score.oriPool[posGe2][i].next;
					goodGenome[i].pos = score.oriPool[posGe2][i].pos;
					goodGenome[i].type = score.oriPool[posGe2][i].type;
				}						
			}
			
			int crossoverN = 0;
			if (stepA[0]/2 > 0)
				crossoverN = (int)rand()%stepA[0]/2;//sorting half way
			else crossoverN = 0;
			
			/********************************************************/
			//do crossover from high score genome to low score genome
			for (int cN = 0; cN < crossoverN; cN++)
			{		
				DcjOperation(dcjGenome, goodGenome, genLen+2);
				CountDcjDistance(dcjGenome, goodGenome, genLen+2, stepA);
			}		
			
			/********************************************************/
			//initial dcjOri and goodOri in case don't pass mutation
			for(int i = 0; i <  genLen+2; i++)
				{
					//dcjOri
					dcjOri[i].geneID = dcjGenome[i].geneID;
					dcjOri[i].marked = dcjGenome[i].marked;
					dcjOri[i].next= dcjGenome[i].next;
					dcjOri[i].pos = dcjGenome[i].pos;
					dcjOri[i].type = dcjGenome[i].type;
					//good genome
					goodOri[i].geneID = goodGenome[i].geneID;
					goodOri[i].marked = goodGenome[i].marked;
					goodOri[i].next= goodGenome[i].next;
					goodOri[i].pos = goodGenome[i].pos;
					goodOri[i].type = goodGenome[i].type;
				}			
			
			//do mutation part mutation the new generation one
			double pro = 0.0;//the probability to excuse the mutation part
			pro = (double)(rand()%100)/100;
			// for the first child
			if (pro < 0.2)
			{				
				int muGen = 1;
				int stepM = 0;				
				CountDcjDistance(dcjGenome, gA, genLen+2, stepA);
				CountDcjDistance(dcjGenome, gB, genLen+2, stepB);
				CountDcjDistance(dcjGenome, gC, genLen+2, stepC);
				// the delta distance with original three genomes A,B,C
				int disA = abs(stepA[0] - dA);
				int disB = abs(stepB[0] - dB);
				int disC = abs(stepC[0] - dC);
				
				int maxDis = disA;
				if (disB > maxDis)
				{
					maxDis = disB;
					muGen = 2;
				}
				if (disC > maxDis)
				{
					maxDis = disC;
					muGen = 3;
				}
			
				if (muGen == 1 && stepA[0] > 0) 
				{
					if (stepA[0] == 0) stepM = (int)rand()%disA;
					else stepM = (int)rand()%stepA[0];
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(dcjGenome, gA, genLen+2);//mutation in gA direction
					}
				}
				
				if (muGen == 2 && stepB[0] > 0) 
				{
					if (stepB[0] == 0) stepM = (int)rand()%disB;
					else stepM = (int)rand()%stepB[0];			
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(dcjGenome, gB, genLen+2);//mutation in gB direction
					}
				}
				
				if (muGen == 3 && stepC[0] > 0) 
				{
					if (stepC[0] == 0) stepM = (int)rand()%disC;
					else stepM = (int)rand()%stepC[0];					
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(dcjGenome, gC, genLen+2);//mutation in gC direction
					}
				}				
			}
			
			// for the second child
			if (pro < 0.2)
			{				
				int muGen = 1;
				int stepM = 0;
				
				CountDcjDistance(goodGenome, gA, genLen+2, stepA);
				CountDcjDistance(goodGenome, gB, genLen+2, stepB);
				CountDcjDistance(goodGenome, gC, genLen+2, stepC);				
				int disA = abs(stepA[0] - dA);
				int disB = abs(stepB[0] - dB);
				int disC = abs(stepC[0] - dC);			
				int maxDis = disA;
				if (disB > maxDis)
				{
					maxDis = disB;
					muGen = 2;
				}
				if (disC > maxDis)
				{
					maxDis = disC;
					muGen = 3;
				}
			
				if (muGen == 1 && stepA[0] > 0) 
				{
					if (stepA[0] == 0) stepM = (int)rand()%disA;
					else stepM = (int)rand()%stepA[0];
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(goodGenome, gA, genLen+2);//mutation in gA direction
					}
				}
				
				if (muGen == 2 && stepB[0] > 0) 
				{
					if (stepB[0] == 0) stepM = (int)rand()%disB;
					else stepM = (int)rand()%stepB[0];				
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(goodGenome, gB, genLen+2);//mutation in gB direction
					}
				}				
				if (muGen == 3 && stepC[0] > 0) 
				{
					if (stepC[0] == 0) stepM = (int)rand()%disC;
					else stepM = (int)rand()%stepC[0];					
					for (int i = 0; i < stepM; i++)
					{
						DcjOperation(goodGenome, gC, genLen+2);//mutation in gC direction
					}
				}		
			}

			//choose 2 from the 4 children plus parents
			//goodGenome, dcjGenome, goodOri, dcjOri
			//compare these four children
			int stepgN = 0;//
			int stepgN2 = 0;
			int stepgN3 = 0;
			int stepgN4 = 0;
			int* stepScore = new int[4];

			
			CountDcjDistance(goodGenome, gA, genLen+2, stepA);
			CountDcjDistance(goodGenome, gB, genLen+2, stepB);
			CountDcjDistance(goodGenome, gC, genLen+2, stepC);
			stepgN = stepA[0] + stepB[0] + stepC[0];
			
			CountDcjDistance(dcjGenome, gA, genLen+2, stepA);
			CountDcjDistance(dcjGenome, gB, genLen+2, stepB);
			CountDcjDistance(dcjGenome, gC, genLen+2, stepC);
			stepgN2 = stepA[0] + stepB[0] + stepC[0];
			
			CountDcjDistance(goodOri, gA, genLen+2, stepA);
			CountDcjDistance(goodOri, gB, genLen+2, stepB);
			CountDcjDistance(goodOri, gC, genLen+2, stepC);
			stepgN3 = stepA[0] + stepB[0] + stepC[0];
			
			CountDcjDistance(dcjOri, gA, genLen+2, stepA);
			CountDcjDistance(dcjOri, gB, genLen+2, stepB);
			CountDcjDistance(dcjOri, gC, genLen+2, stepC);
			stepgN4 = stepA[0] + stepB[0] + stepC[0];
			
			stepScore[0] = stepgN;
			stepScore[1] = stepgN2;
			stepScore[2] = stepgN3;
			stepScore[3] = stepgN4;
		
		  int min = stepgN;
			int minG = 1;
			if (stepgN2 < min)
			{
				minG = 2;
				min = stepgN2;
			}
			if (stepgN3 < min)
			{
				minG = 3;
				min = stepgN3;
			}
			if (stepgN4 < min)
			{
				minG = 4;
				min = stepgN4;
			}			
			int select1 = minG;//the first low distance genome
			stepScore[minG-1] = 500;//reset the first min Score and record  the # is minG
			min = stepScore[0];
			minG = 1;
			if (stepScore[1] < min)
			{
				minG = 2;
				min = stepScore[1];
			}
			if (stepScore[2] < min)
			{
				minG = 3;
				min = stepScore[2];
			}
			if (stepScore[3] < min )
			{
				minG = 4;
				min = stepScore[3];
			}
			int select2 = minG;//second low distance genome			
			//get the best two genome
			//goodGenome, dcjGenome, goodOri, dcjOri
			if (select1 == 1)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2][t] = goodGenome[t];
					}
				}
			if (select1 == 2)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2][t] = dcjGenome[t];
					}
				}
			if (select1 == 3)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2][t] = goodOri[t];
					}
				}
			if (select1 == 4)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2][t] = dcjOri[t];
					}
				}					
			//goodGenome, dcjGenome, goodOri, dcjOri
			if (select2 == 1)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2+1][t] = goodGenome[t];
					}
				}
			if (select2 == 2)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2+1][t] = dcjGenome[t];
					}
				}
			if (select2 == 3)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2+1][t] = goodOri[t];
					}
				}
			if (select2 == 4)
				{
						for (int t = 0; t < genLen+2; t++) 
					{
						score.newPool[blockExNum*2+1][t] = dcjOri[t];
					}
				}
				
			CountDcjDistance(score.newPool[blockExNum*2], goodGenome, genLen+2, stepA);
			CountDcjDistance(score.newPool[blockExNum*2+1], goodGenome, genLen+2, stepA);		
			blockExNum++;
		}
		
		for(int k = 0; k < 10; k++)
		{
			iniGe(score.newPool[popGe-10+k], score.recordGes[k], geLen);			
		}

		for (int i = 0; i < popGe; i++)
    {			
			CountDcjDistance(score.newPool[i], gA, genLen+2, stepA);
			CountDcjDistance(score.newPool[i], gB, genLen+2, stepB);
			CountDcjDistance(score.newPool[i], gC, genLen+2, stepC);           				
			score.sumScore[i].score =  stepA[0] + stepB[0] + stepC[0];
      medScoreArray[i].score = score.sumScore[i].score;
      medScoreArray[i].pos = i;//record the position of genome
    }
		sort(medScoreArray.begin(), medScoreArray.end(), compfunction);

		//replace the worst genomes using best genomes
		for (int i = 0; i < replNum; i++)
		{
			int posb = 0; 
			int posw = 0;
			posb = medScoreArray[i].pos;
			posw = medScoreArray[popGe-i-1].pos;			
			iniGe(score.newPool[posw], score.newPool[posb], geLen);		
		}	
		for(int i = 0; i < popGe; i++)
		{
			for (int j = 0; j < genLen+2; j++)
			{
				score.oriPool[i][j].geneID = score.newPool[i][j].geneID;
				score.oriPool[i][j].marked = score.newPool[i][j].marked;
				score.oriPool[i][j].next = score.newPool[i][j].next;
				score.oriPool[i][j].pos = score.newPool[i][j].pos;
				score.oriPool[i][j].type = score.newPool[i][j].type;
			}
		}	

	  outf << "done "<< generN << " gene generation"<< endl;		
    generN++;	  
     
	}while (generN < MaxGenerNum);

	 sort(medScoreArray.begin(), medScoreArray.end(), compfunction);
	 for(int i = 0; i < popGe; i++)
	{				
		CountDcjDistance(score.newPool[i], gA, genLen+2, stepA);
		CountDcjDistance(score.newPool[i], gB, genLen+2, stepB);
		CountDcjDistance(score.newPool[i], gC, genLen+2, stepC);    		
	}
	it = medScoreArray.begin();// get the struct element we need
    rePosition = (*it).pos;
	CountDcjDistance(score.newPool[rePosition], gA, genLen+2, stepA);
	CountDcjDistance(score.newPool[rePosition], gB, genLen+2, stepB);
	CountDcjDistance(score.newPool[rePosition], gC, genLen+2, stepC); 

	outf << "the min total score + disdev is: " << (*it).score << endl;
	outf <<"the min total distance is: " << stepA[0] + stepB[0]  + stepC[0] << endl;
	outf << "the distance of the gA genomes is: " << stepA[0] << "the distance of the gB genomes is: "<< stepB[0]<< "the distance of the gC genomes is: "<< stepC[0]<< endl;
	outf << "the min genome is"<< endl;
	for (int i = 0; i < genLen+2; i++)
		{		
			outf << "gene order ID: " <<score.newPool[rePosition][i].geneID << "    adjacency ID: " << score.newPool[rePosition][i].next << "   "<< endl;
		}
	//distance with identity genome
	geNome ** geneABC = new geNome *[3];
		for (int i = 0; i < 3; i++)
		{
			geneABC[i] = new geNome[geLen*2 + 2];
		}
	geNome* idenGenome = new geNome[genLen + 2];		
		
		geneABC = iniGenome(1, geLen, filepath);
		//printGenoFun(geneABC, geLen*2 + 2, 3);
		for (int i = 0; i < geLen*2 + 2; i++)
		{
			idenGenome[i] = geneABC[0][i];
		}		
	
	//iniCalGenome(idenGenome, geLen, filepath);
	CountDcjDistance(score.newPool[rePosition], idenGenome, genLen+2, stepA);
	outf << "the distance between median with internal genome is: "<< stepA[0] << endl;

	//delete
	delete[] stepA;
	delete[] stepB;
	delete[] stepC;
	delete[] oriGene;
	delete[] dcjGenome;
	delete[] dcjOri;
	delete[] goodGenome;
	delete[] goodOri;
	delete[] idenGenome;
	delete[] geneABC;
}




                         