/* 
 * fILE:   main.cpp
 * Author: Nan Gao
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <fstream>
#include <iostream>
#include "AjacencyGraphy.h"
#include "DcjDistance.h"
#include "DcjOperation.h"
#include "GaOperation.h"
#include "structs.h"
#include "ASortingSequence.h"
#include "aSortingSeq.h"

using namespace std;
 int *mark, *pred, *label, *idx;
 int* is_separator, *sepclass, *bc_hurdchain,
            *lidx, *llabel, *is_separated;
int *comp_label_copy, *inv_copy;
List l;
List m;
void CreateDistmem(int num_genes) ;
char* tmpOut;
void FreeDistmem() ;
geNome *GaOperation(geNome *gA, geNome *gB, geNome *gC, int geLen, int pop, char *pathOut, Score score, List l, List m, char *filepath);
distmem_t distmem;
void CreateScore(int pop, int geLen);
void FreeScore(int pop);
Score score;

void iniGe (geNome* gA, geNome* gB, int geLen)//using gB to initial gA, geLen = 200
{
	for (int i = 0 ; i < geLen*2 +2 ; i++)
		{
			gA[i].geneID = gB[i].geneID;
			gA[i].marked = gB[i].marked;
			gA[i].next = gB[i].next;
			gA[i].pos = gB[i].pos;
			gA[i].type = gB[i].type;
		}
}

int main(int argc, char** argv) {
    if (argc == 9) // pop#, gene length, iterator#, read file, output file for parent pool, output stepfile, output result file, ancestor file
	{
		srand(unsigned(time(NULL)));
		int pop = atoi(argv[1]);
		int geLen = atoi(argv[2]);
		int num = atoi(argv[3]);//iterator number for every aSortingSeq in order to generate parents pool
		int N = geLen;
	
		cout << geLen << endl;
		geNome *gA = NULL;
		geNome *gB = NULL;
		geNome *gC = NULL;
		geNome *medGenome = NULL;
		FILE *fs;

		char *filePath;
		char *fileOut;
		char *stepFile;
		char *resultFile;
		char *idfilePath;
		filePath = argv[4];//read filePath
		fileOut = argv[5];//outPut filePath for parent pool and read filepath for genetic
		stepFile = argv[6];//outPut stepfilePath
		resultFile = argv[7];//output the result file
		idfilePath = argv[8];// interval nodes file path
		CreateScore(pop, geLen);

		char *a;
		int *gene1;
		int *geneb1;
		int *gene2;
		int *geneb2;
		int *gene3;
		int *geneb3;
		int gene = 0;

    CreateDistmem(N);
		gene1 = new int[N];
	  geneb1 = new int[N];
		gene2 = new int[N];
		geneb2 = new int[N];
		gene3 = new int[N];
		geneb3 = new int[N];
		gA = new geNome[geLen*2 + 2];
		gB = new geNome[geLen*2 + 2];
		gC = new geNome[geLen*2 + 2];
		

		int* step = new int[2]; 
		//CreateScore(pop, geLen);
		
		geNome **geneABC = NULL;
		geneABC = new geNome *[3];
		for (int i = 0; i < 3; i++)
		{
			geneABC[i] = new geNome[geLen*2 + 2];
		}
		cout << argc << endl;
		/***********************************************/
		//start read gA, gB, gC
		
		geneABC = iniGenome(3, geLen, filePath);
		for (int i = 0; i < geLen*2 + 2; i++)
		{
			gA[i] = geneABC[0][i];
		}
		
		for (int i = 0; i < geLen*2 + 2; i++)
		{
			gB[i] = geneABC[1][i];
		}
		
		for (int i = 0; i < geLen*2 + 2; i++)
		{
			gC[i] = geneABC[2][i];
		}
		
		ifstream fin(filePath);
		while (!fin.eof())
		{
			int k = 0;
			for( k = 0; k < 3; k++)
			{								
				for(int q = 0; q < N; q++)
					{
						if ( k == 0) { fin >> gene; gene1[q] = gene; geneb1[q] = gene;}
						if ( k == 1) { fin >> gene; gene2[q] = gene; geneb2[q] = gene;}
						if ( k == 2) { fin >> gene; gene3[q] = gene; geneb3[q] = gene;}
					}				
			}
			if (k >= 3) break;
		}
		fin.close();
		
		geNome* gAgenome = new geNome[geLen*2 + 2];
		geNome* gBgenome = new geNome[geLen*2 + 2];
		geNome* gCgenome = new geNome[geLen*2 + 2];
		int* stepAB = new int[3];
		int* stepAC = new int[3];
		int* stepBC = new int[3];
		int totalStep = 0;
		int comN = 0;
		int indexOri = 0;

		iniGe(gAgenome, gA, geLen);// back to initial front
		iniGe(gBgenome, gB, geLen);
		iniGe(gCgenome, gC, geLen);		


		CountDcjDistance(gA, gC, 2*N+2, stepAC);
		fs = fopen(stepFile, "a");
		a = "gA to gC step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepAC[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
		CountDcjDistance(gA, gB, 2*N+2, stepAB);
		fs = fopen(stepFile, "a");
		a = "gA to gB step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepAB[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
		CountDcjDistance(gC, gB, 2*N+2, stepBC);
		fs = fopen(stepFile, "a");
		a = "gC to gB step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepBC[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
	
		CountDcjDistance(gC, gA, 2*N+2, stepAC);
		fs = fopen(stepFile, "a");
		a = "gA to gC step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepAC[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
	
		CountDcjDistance(gB, gA, 2*N+2, stepAB);
		fs = fopen(stepFile, "a");
		a = "gB to gA step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepAB[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
		CountDcjDistance(gB, gC, 2*N+2, stepBC);
		fs = fopen(stepFile, "a");
		a = "gB to gC step: ";		
		fprintf(fs, "%s",a);
		fprintf(fs, "%d ",stepBC[0]);
		fprintf(fs, "\n\r");
		fclose(fs);
		
		ofstream outf(fileOut);
		
		//for gA to gB
		totalStep = stepAB[0];
		for (int k = 0; k < num; k++)
		{			
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gA, gB, 2*N+2, stepAB);//refresh the distance and component between gA and gB
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepAB[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gA[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepAB[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gA[i].marked == comN)
						{
							count++;		
						}
					}				
				}
				DcjOperation(gA, gB, 2*N+2);	
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
			}
			//initial gA
			iniGe(gA, gAgenome, geLen);
			CountDcjDistance(gA, gB, 2*N+2, stepAB);
			totalStep = stepAB[0];
		}

		//for gB to gA
		iniGe(gA, gAgenome, geLen);
		iniGe(gB, gBgenome, geLen);
		CountDcjDistance(gB, gA, 2*N+2, stepAB);	
		totalStep = stepAB[0];
		outf << " for gB to gA " << endl;
		for (int k = 0; k < num; k++)
		{
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gB, gA, 2*N+2, stepAB);//refresh the distance and component between gA and gB	
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepAB[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gB[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepAB[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gB[i].marked == comN)
						{
							count++;		
						}
					}			
				}
				DcjOperation(gB, gA, 2*N+2);
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
			}
			iniGe(gB, gBgenome, geLen);
			CountDcjDistance(gB, gA, 2*N+2, stepAB);
			totalStep = stepAB[0];
		}

		//for gA to gC	
		iniGe(gA, gAgenome, geLen);
		iniGe(gB, gBgenome, geLen);
		iniGe(gC, gCgenome, geLen);
		CountDcjDistance(gA, gC, 2*N+2, stepAC);
		totalStep = stepAC[0];// the total step between gB and gA		
		outf << " for gA to gC " << endl;
		for (int k = 0; k < num; k++)
		{			
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gA, gC, 2*N+2, stepAC);//refresh the distance and component between gA and gB
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepAC[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gA[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepAC[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gA[i].marked == comN)
						{
							count++;		
						}
					}	
				}

				DcjOperation(gA, gC, 2*N+2);
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);					
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gA, geLen);
					indexOri++;
				}
			}
			//initial gA
			iniGe(gA, gAgenome, geLen);
			CountDcjDistance(gA, gC, 2*N+2, stepAC);
			totalStep = stepAC[0];
		}

		//for gC to gA
		iniGe(gA, gAgenome, geLen);
		iniGe(gB, gBgenome, geLen);
		iniGe(gC, gCgenome, geLen);
		CountDcjDistance(gC, gA, 2*N+2, stepAC);
		totalStep = stepAC[0];// the total step between gB and gA
	
		for (int k = 0; k < num; k++)
		{
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gC, gA, 2*N+2, stepAC);//refresh the distance and component between gA and gB
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepAC[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gC[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepAC[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gC[i].marked == comN)
						{
							count++;		
						}
					}	
				}
				
				DcjOperation(gC, gA, 2*N+2);
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
			}
			//initial gC
			iniGe(gC, gCgenome, geLen);
			CountDcjDistance(gC, gA, 2*N+2, stepAC);
			totalStep = stepAC[0];
		}

		//for gB to gC
		iniGe(gA, gAgenome, geLen);
		iniGe(gB, gBgenome, geLen);
		iniGe(gC, gCgenome, geLen);
		CountDcjDistance(gB, gC, 2*N+2, stepBC);
		totalStep = stepBC[0];// the total step between gB and gA
		cout << stepBC[0] << endl;
		for (int k = 0; k < num; k++)
		{
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gB, gC, 2*N+2, stepBC);//refresh the distance and component between gA and gB
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepBC[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gB[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepBC[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gB[i].marked == comN)
						{
							count++;		
						}
					}	
				}
				
				DcjOperation(gB, gC, 2*N+2);
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gB, geLen);
					indexOri++;
				}
			}
			//initial gB
			iniGe(gB, gBgenome, geLen);
			CountDcjDistance(gB, gC, 2*N+2, stepBC);
			totalStep = stepBC[0];
		}

		//for gC to gB
		iniGe(gA, gAgenome, geLen);
		iniGe(gB, gBgenome, geLen);
		iniGe(gC, gCgenome, geLen);
		CountDcjDistance(gC, gB, 2*N+2, stepBC);
		totalStep = stepBC[0];// the total step between gB and gA
		for (int k = 0; k < num; k++)
		{
			for (int i = 0; i < totalStep; i++)
			{
				CountDcjDistance(gC, gB, 2*N+2, stepBC);//refresh the distance and component between gA and gB
				//choose component element >= 4
				int count = 0;
				comN = (int)rand()%stepBC[1] + 1;
				for (int i = 0; i < 2*N+2; i++)
				{
					if (gC[i].marked == comN)
					{
						count++;		
					}
				}				
				while(count < 4)
				{
					count = 0;
					comN = (int)rand()%stepBC[1] + 1;
					for (int i = 0; i < 2*N+2; i++)
					{
						if (gC[i].marked == comN)
						{
							count++;		
						}
					}	
					
				}
			
				DcjOperation(gC, gB, 2*N+2);
				if (i == totalStep/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*3/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*2/5)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*1/2)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
				if (i == totalStep*6/10)//put it in the origPool
				{
					iniGe(score.oriPool[indexOri], gC, geLen);
					indexOri++;
				}
			}
			//initial gC
			iniGe(gC, gCgenome, geLen);
			CountDcjDistance(gC, gB, 2*N+2, stepBC);
			totalStep = stepBC[0];
		}

		medGenome = new geNome[geLen*2 + 2];				
		//reinitial gA, gB and gC
		for (int i = 0 ; i < geLen*2 +2 ; i++)
		{
			gA[i] = gAgenome[i];	
			gB[i] = gBgenome[i];	
			gC[i] = gCgenome[i];
		}
		CountDcjDistance(gA, gB, 2*N+2, stepBC);
		CountDcjDistance(gC, gB, 2*N+2, stepBC);
		CountDcjDistance(gA, gC, 2*N+2, stepBC);

		//do GA_DcjOpperation
		GaDcjOperation(gA, gB, gC, geLen, pop, resultFile, score, idfilePath);


		delete[] gene1;
		delete[] gene2;
		delete[] gene3;
		delete[] geneb1;
		delete[] geneb2;
		delete[] geneb3;
		delete[] gA;
		delete[] gB;
		delete[] gC;
		delete[] medGenome;
		delete[] step;
		delete[] stepAB;
		delete[] stepAC;
		delete[] stepBC;

		for (int u = 0; u < 3; u++)
		delete[] geneABC[u];
		delete[] geneABC;
		geneABC = NULL;
		//FreeScore(pop);
 
     FreeDistmem();
	}
	else
	{
		cout << "please input the right number of argvs: pop#, gene length, iterator#, read file, output file for parent pool, output stepfile, output result file, ancestor file "<< endl;
	}
	    
    return 0;
}

void CreateDistmem(int num_genes) {
    distmem.perm1 =        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.perm1 == ( int * ) NULL )
        fprintf ( stderr, "ERROR: perm1 NULL\n" );
    distmem.perm2 =        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.perm2 == ( int * ) NULL )
        fprintf ( stderr, "ERROR: perm2 NULL\n" );
    distmem.perm =        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.perm == ( int * ) NULL )
        fprintf ( stderr, "ERROR: perm NULL\n" );
    distmem.done =        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.done == ( int * ) NULL )
        fprintf ( stderr, "ERROR: done NULL\n" );
    distmem.greyEdges =        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.greyEdges == ( int * ) NULL )
        fprintf ( stderr, "ERROR: greyEdges NULL\n" );

    distmem.stack =
        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.stack == ( int * ) NULL )
        fprintf ( stderr, "ERROR: stack NULL\n" );
    distmem.oriented =
        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.oriented == ( int * ) NULL )
        fprintf ( stderr, "ERROR: oriented NULL\n" );
    distmem.cc = ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.cc == ( int * ) NULL )
        fprintf ( stderr, "ERROR: cc NULL\n" );
    distmem.labeled =
        ( int * ) malloc ( ( 2 * num_genes + 2 ) * sizeof ( int ) );
    if ( distmem.labeled == ( int * ) NULL )
        fprintf ( stderr, "ERROR: labeled NULL\n" );
    distmem.components = ( component_t * )
        malloc ( ( 2 * num_genes + 2 ) * sizeof ( component_t ) );
    if ( distmem.components == ( component_t * ) NULL )
        fprintf ( stderr, "ERROR: components NULL\n" );
     mark = (int*)malloc(num_genes*sizeof(int)); pred = (int*)malloc(num_genes*sizeof(int));
     label = (int*) malloc(num_genes*sizeof(int)); idx = (int*)malloc(num_genes*sizeof(int));

	comp_label_copy = ( int * ) malloc ( num_genes * sizeof ( int ) );
    inv_copy = ( int * ) malloc ( num_genes * sizeof ( int ) );

	is_separator = (int*)malloc(sizeof(int)*num_genes);
                sepclass = (int*)malloc(sizeof(int)*num_genes);
                bc_hurdchain = (int*)malloc(sizeof(int)*num_genes);
    lidx = (int*)malloc(sizeof(int)*num_genes);
                llabel = (int*)malloc(sizeof(int)*num_genes);
                is_separated = (int*)malloc(sizeof(int)*num_genes);
                
    init_list(&l, (num_genes+1)*num_genes, sizeof (Reversal*));
    init_list(&m, (num_genes+1)*num_genes, sizeof (Reversal*));

}

void FreeDistmem() {
    free ( distmem.components );
    free ( distmem.labeled );
    free ( distmem.cc );
    free ( distmem.oriented );
    free ( distmem.stack );
    free ( distmem.greyEdges );
    free ( distmem.done );
    free ( distmem.perm1 );
    free ( distmem.perm2 );
    free ( distmem.perm );
	free(mark); free(pred); free(label); free(idx);
	free(is_separator);
    free(sepclass);
    free(bc_hurdchain);
    free(lidx);
    free(llabel);
    free(is_separated);
	free ( comp_label_copy );
    free ( inv_copy );
	free_list(&l);
    free_list(&m);
}

void CreateScore(int pop, int geLen)
{
	int genLen = geLen*2;
	score.scoreA = new dcjScore[pop];
	score.scoreB = new dcjScore[pop];
	score.scoreC = new dcjScore[pop];
	score.ratScore = new ratioScore[pop];
	score.sumScore = new dcjScore[pop];
	score.newGenomes = new geNome *[2];
	for (int j = 0; j < 2; j++)
	{
		score.newGenomes[j] = new geNome[genLen+2];
	}
	score.newPool = new geNome *[pop];
    for (int u = 0; u < pop; u++)
    {
         score.newPool[u] = new geNome[genLen+2];
    }
	score.recordGes = new geNome *[10];
	for (int j = 0; j < 10; j++)
	{
		score.recordGes[j] = new geNome[genLen+2];
	}
	score.oriPool = new geNome *[pop];
	for (int i = 0; i < pop; i++)
	{
		score.oriPool[i] = new geNome[genLen+2];
	}
}

void FreeScore(int pop)
{
	delete[] score.scoreA;
	delete[] score.scoreB;
	delete[] score.scoreC;
	delete[] score.ratScore;
	delete[] score.sumScore;
	for (int q = 0; q < 2; q++)	
		delete[] score.newGenomes[q];			
	delete[] score.newGenomes;
	score.newGenomes = NULL;
	 for (int u = 0; u < pop; u++)    
        delete[] score.newPool[u];    
    delete[] score.newPool;
	score.newPool = NULL;
	for (int u = 0; u < 10; u++)
        delete[] score.recordGes[u];    
    delete[] score.recordGes;
	score.recordGes = NULL;
	//for (int u = 0; u < pop; u++)
		//delete[] score.oriPool[u];
	//delete[] score.oriPool;
	//score.oriPool = NULL;
}

